"""
@author: Fernando Penaherrera @UOL/OFFIS

This class couples the Grid Corrector class to the MOSAIK API

"""

import itertools
import mosaik_api
from src.components.grid_corrector import grid_corrector

# SIMULATION META DATA
META = {
    "type": "time-based",
    "models": {
        "GridCorrector": {
            "public": True,
            "params": [
                "init_vals",  # Initial Values. Dictionary
            ],
            "attrs": [
                "status",
                "net",
                "b_p_inj",
            ],
        },
        "Bus_P_inj": {
            "public": True,
            "params": [],
            "attrs": [
                "p_mw",
            ],
        },
    },
    "extra_methods": [
        "get_entities",
    ],
}

# ------------INPUT-SIGNALS--------------------
# status         Status of the Grid. True = No violations, False = Violations
# net            A pandapower net to be evaluated for correction.

# ------------OUTPUT-SIGNALS--------------------
# b_p_inj        Bus Power Injection. A dict with bus number and required power correction in W.


class Sim(mosaik_api.Simulator):
    def __init__(self):
        """Constructor"""
        super(Sim, self).__init__(META)

        # assign properties
        self.step_size = None

        # create dict for entities and eid_counters
        self.entities = {}
        self.eid_counters = {}

        # init Simulator of model
        self.simulator = grid_corrector.Simulator()

    # init API
    def init(self, sid, time_resolution=1, start_date=None, step_size=1):
        """Initializer for the class. Uses MOSAIK API

        Args:
            sid (int): Class ID
            time_resolution (int, optional): Time Resolution. Defaults to 1.
            start_date (int, optional): Start Date. Defaults to None.
            step_size (int, optional): Time step size. Defaults to 1.

        Returns:
            dict: Metadata of the Simulator Class
        """
        # assign properties
        self.sid = sid
        self.time_resolution = time_resolution
        self.step_size = step_size

        # return meta data
        return self.meta

    # create model
    def create(self, num=1, model_type=None, init_vals=None):
        """Creates a number of instances of the model

        Args:
            num (int): Number of instances of the model. Defaults to 1.
            model_type (Class): Class description of the model type. Defaults to None.
            init_vals (dict, optional): Initial values for the models. Defaults to None.

        Raises:
            ValueError: Only one entity can be created

        Returns:
            list: List with all the entities descriptions (each one as dict)
        """

        if num != 1:
            raise ValueError("Only one entity can be created")

        counter = self.eid_counters.setdefault(model_type, itertools.count())

        # create list for entities
        entities = []

        for _ in range(num):
            # TODO These methods for string creation are deprecated. use f"{}""
            eid = "{}_{}".format(model_type, next(counter))  # Create ntities IDs

            # create new Grid Observer model
            model = self.simulator.add_model(init_vals[0] if init_vals is not None else None)

            # create full id
            full_id = self.sid + "." + eid

            self.entities[eid] = {
                "ename": eid,
                "etype": model_type,
                "model": model,
                "full_id": full_id,
            }
            entities.append({"eid": eid, "type": model_type, "rel": []})

        return entities

    def step(self, time, inputs, max_advance=360000):
        """Perform calculation step and advance the time

        Args:
            time (int): Time Step Size
            inputs (dict): Dictionary of inputs. Given by MOSAIK
            max_advance (int, optional): Max Time Advance. Defaults to 360000.

        Returns:
            int: New time stamp
        """
        self.cache = {}

        for _, attrs in inputs.items():
            status = None
            for attr, vals in attrs.items():
                if attr == "status":
                    status = list(vals.values())[0]
                if attr == "net":
                    net = list(vals.values())[0]

        # Perform simulation step
        self.simulator.step(time, status, net)

        # Next timestamp for simulation
        return time + self.step_size

    # get data
    def get_data(self, outputs):
        """The outputs expected are under the property model.bus_p_inj and correspond
        to a dictionary with bus number and expected power injection. This is to
        be passed to a dataclass simulator that can distribute this information within
        MOSAIK

        Raises:
            ValueError: Error if the attribute not in th metadata

        Returns:
            dict: Dictionary with outputs generated by MOSAIK
        """

        # create output data
        data = {}

        # loop over all output values
        for ename, attrs in outputs.items():

            # set data entry for model
            data[ename] = {}

            # loop over all attributes
            for attr in attrs:
                if attr not in self.meta["models"]["GridCorrector"]["attrs"]:
                    raise ValueError("Unknown output attribute: %s" % attr)

                # Get model data
                if attr == "b_p_inj":
                    data[ename][attr] = self.entities[ename]["model"].bus_p_inj

        return data

    # Get entities

    def get_entities(self):
        """Return entities of API

        Returns:
            list: List with dicts containing entities information
        """
        return self.entities
